				//*********************************************************************************
				//
				//     This program is free software; you can redistribute it and/or modify
				//     it under the terms of the GNU General Public License as published by
				//     the Free Software Foundation; either version 2 of the License, or
				//     (at your option) any later version.
				//
				//     This program is distributed in the hope that it will be useful,
				//     but WITHOUT ANY WARRANTY; without even the implied warranty of
				//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
				//     GNU General Public License for more details.
				//
				//    You should have received a copy of the GNU General Public License along
				//    with this program; if not, write to the Free Software Foundation, Inc.,
				//    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
				//    
				//    A copy of the GNU General Public License is also available at
				//    http://www.fsf.org/licensing/licenses
				//
				//*********************************************************************************

				FILE* MEMRES, *ERRES;

				MEMRES=fopen("MEM_spec_rec_alpha.dat","r");
				
				ERRES=fopen("MEM_DCDXDATA.dat","r");

				double val1,val2,val3,val4,val5,val6,val7,val8,val9,val10;
				int ival1,ival2,ival3,ival4,ival5,ival6;
				
				if(acnt<ANUM){

					for(int xl=0;xl<DX;xl++){
						
						for(int k=0;k<ANUM;k++){

							for(int w=0; w<NOMEGA; w++){
								
								fscanf(MEMRES,"%d %lf %d %lf %lf %lf %lf %lf %lf %d %d %lf %lf %lf\n", &ival1,&val1,&ival2,&val2,&val3,&val4,&val5,&val6,&val7,&ival3, &ival4, &val8,&val9,&val10);
								//fscanf(MEMRES,"%d %lf %d %lf %lf %lf %lf %lf %lf %d %d %lf %lf %lf\n", DX,AMIN+(acnt+1.)*(AMAX-AMIN)/ANUM,w,mpfr_get_d(omega->data[w],GMP_RNDN), GNUPR(gslgmp_vector_get_d(A,w))/pow(domega[w],PRIORPOWER),ERRS[acnt][w/(NOMEGA/ERRNUM)]/pow(domega[w],PRIORPOWER),GNUPR(gslgmp_vector_get_d(A,w)),ERRS[acnt][w/(NOMEGA/ERRNUM)],mpfr_get_d(LOGPROB->data[acnt],GMP_RNDN),JCNT,REP,GNUPR(gslgmp_vector_get_d(Adw,w)),Qvals[acnt],Lvals[acnt] );
								
								if(ival1!=xl || ival2!=w) { fprintf(stderr, "PROBLEM WITH FILE (loop - file) dx:%d - %d and w: %d - %d\n", xl,ival1,w,ival2); exit(-1);}
							}
						}
					    
						for(int dt=NTMIN;dt<=NTMAX;dt++){
							
							fscanf(ERRES,"%d %lf %lf %lf %lf %lf\n",&ival1,&val1,&val2,&val3,&val4,&val5);
							
							if(ival1!=xl+1 || fabs(val1-mpfr_get_d(tau->data[dt-NTMIN],GMP_RNDN))>1e-8 ) { fprintf(stderr, "PROBLEM WITH ERRORS FILE (loop - file) dx:%d - %d and dt: %e - %e\n", xl+1,ival1,mpfr_get_d(tau->data[dt],GMP_RNDN),val1); exit(-1);}
							
							//fprintf(avgout,"%d %.15e %.15e %.15e %.15e %.15e\n",DX+1,gslgmp_vector_get_d(tau,dt-NTMIN),gslgmp_vector_get_d(DCDXData,dt-NTMIN),sqrt(gslgmp_vector_get_d(CEval,dt-NTMIN)),sqrt(gslgmp_matrix_get_d(Corr,dt-NTMIN,dt-NTMIN)),gslgmp_vector_get_d(DXData,dt-NTMIN));
						}
					    
					    
					    
					}

					for(int k=0;k<ANUM-acnt-1;k++){

						for(int w=0; w<NOMEGA; w++){
							
							fscanf(MEMRES,"%d %lf %d %lf %lf %lf %lf %lf %lf %d %d %lf %lf %lf\n", &ival1,&val1,&ival2,&val2,&val3,&val4,&val5,&val6,&val7,&ival3, &ival4, &val8,&val9,&val10);
							//fscanf(MEMRES,"%d %lf %d %lf %lf %lf %lf %lf %lf %d %d %lf %lf %lf\n", DX,AMIN+(acnt+1.)*(AMAX-AMIN)/ANUM,w,mpfr_get_d(omega->data[w],GMP_RNDN), GNUPR(gslgmp_vector_get_d(A,w))/pow(domega[w],PRIORPOWER),ERRS[acnt][w/(NOMEGA/ERRNUM)]/pow(domega[w],PRIORPOWER),GNUPR(gslgmp_vector_get_d(A,w)),ERRS[acnt][w/(NOMEGA/ERRNUM)],mpfr_get_d(LOGPROB->data[acnt],GMP_RNDN),JCNT,REP,GNUPR(gslgmp_vector_get_d(Adw,w)),Qvals[acnt],Lvals[acnt] );
							
							if(ival1!=DX || ival2!=w) { fprintf(stderr, "PROBLEM WITH FILE DX: %d %d (loop - file) and w: %d - %d\n", DX,ival1,w,ival2); exit(-1);}
						}
					}
					
					for(int w=0; w<NOMEGA; w++){
						fscanf(MEMRES,"%d %lf %d %lf %lf %lf %lf %lf %lf %d %d %lf %lf %lf\n", &ival1,&val1,&ival2,&val2,&val3,&val4,&val5,&val6,&val7,&ival3, &ival4, &val8,&val9,&val10);
						//fscanf(MEMRES,"%d %lf %d %lf %lf %lf %lf %lf %lf %d %d %lf %lf %lf\n", DX,AMIN+(acnt+1.)*(AMAX-AMIN)/ANUM,w,mpfr_get_d(omega->data[w],GMP_RNDN), GNUPR(gslgmp_vector_get_d(A,w))/pow(domega[w],PRIORPOWER),ERRS[acnt][w/(NOMEGA/ERRNUM)]/pow(domega[w],PRIORPOWER),GNUPR(gslgmp_vector_get_d(A,w)),ERRS[acnt][w/(NOMEGA/ERRNUM)],mpfr_get_d(LOGPROB->data[acnt],GMP_RNDN),JCNT,REP,GNUPR(gslgmp_vector_get_d(Adw,w)),Qvals[acnt],Lvals[acnt] );
						
						int testbad=0;
						int tst1=0;
						int tst2=0;
						int tst3=0;
						
						if(ival1!=DX) {testbad=1; tst1=1;}
						if(ival2!=w) {testbad=1; tst2=1;}
						if( fabs(val1- alpha)>1e-8 )  {testbad=1; tst3=1;}
						
						if(testbad==1) { fprintf(stderr, "PROBLEM WITH FILE (loop - file) dx:%d - %d and w: %d - %d alpha: %e - %e T1:%d T2:%d T3:%d\n", DX,ival1,w,ival2, alpha, val1,tst1,tst2,tst3); exit(-1);}
						
						mpfr_set_d(blbfgs->data[w], (val5>1e-32?val5:1e-32) ,GMP_RNDN);
						fprintf(stderr, "DX: %d ALPHA: %e OEMGA:%d VALUE:%e\n", DX,alpha, w,mpfr_get_d(blbfgs->data[w],GMP_RNDN));
						
						mpfr_set_d(Lval,val10,GMP_RNDN);
						mpfr_set_d(Sval,  -(val9 - mpfr_get_d(Lval,GMP_RNDN))/alpha , GMP_RNDN);
					}
					
					for(int dt=NTMIN;dt<=NTMAX;dt++){
						
						fscanf(ERRES,"%d %lf %lf %lf %lf %lf\n",&ival1,&val1,&val2,&val3,&val4,&val5);
						
						if(ival1!=DX+1 || fabs(val1-mpfr_get_d(tau->data[dt-NTMIN],GMP_RNDN))>1e-8 ) { fprintf(stderr, "PROBLEM WITH ERRORS FILE (loop - file) dx:%d - %d and dt: %e - %e\n", DX+1,ival1,mpfr_get_d(tau->data[dt-NTMIN],GMP_RNDN),val1); exit(-1);}
						
						
						mpfr_set_d(CEval->data[dt-NTMIN], val3*val3, GMP_RNDN);
						
						//fprintf(avgout,"%d %.15e %.15e %.15e %.15e %.15e\n",DX+1,gslgmp_vector_get_d(tau,dt-NTMIN),gslgmp_vector_get_d(DCDXData,dt-NTMIN),sqrt(gslgmp_vector_get_d(CEval,dt-NTMIN)),sqrt(gslgmp_matrix_get_d(Corr,dt-NTMIN,dt-NTMIN)),gslgmp_vector_get_d(DXData,dt-NTMIN));
					}
					
					gmpPVec(CEval);
				}
				
				fclose(MEMRES);				
				fclose(ERRES);